Merge branch 'js/status-pre-rebase-i'
[git/git-svn.git] / git-submodule.sh
blob123ac104c6f312cc27f1ddf925c80b386bfd4f23
1 #!/bin/sh
3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
16 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
17 OPTIONS_SPEC=
18 SUBDIRECTORY_OK=Yes
19 . git-sh-setup
20 . git-parse-remote
21 require_work_tree
22 wt_prefix=$(git rev-parse --show-prefix)
23 cd_to_toplevel
25 # Tell the rest of git that any URLs we get don't come
26 # directly from the user, so it can apply policy as appropriate.
27 GIT_PROTOCOL_FROM_USER=0
28 export GIT_PROTOCOL_FROM_USER
30 command=
31 branch=
32 force=
33 reference=
34 cached=
35 recursive=
36 init=
37 files=
38 remote=
39 nofetch=
40 update=
41 prefix=
42 custom_name=
43 depth=
44 progress=
46 die_if_unmatched ()
48 if test "$1" = "#unmatched"
49 then
50 exit ${2:-1}
55 # Print a submodule configuration setting
57 # $1 = submodule name
58 # $2 = option name
59 # $3 = default value
61 # Checks in the usual git-config places first (for overrides),
62 # otherwise it falls back on .gitmodules. This allows you to
63 # distribute project-wide defaults in .gitmodules, while still
64 # customizing individual repositories if necessary. If the option is
65 # not in .gitmodules either, print a default value.
67 get_submodule_config () {
68 name="$1"
69 option="$2"
70 default="$3"
71 value=$(git config submodule."$name"."$option")
72 if test -z "$value"
73 then
74 value=$(git config -f .gitmodules submodule."$name"."$option")
76 printf '%s' "${value:-$default}"
79 isnumber()
81 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
84 # Sanitize the local git environment for use within a submodule. We
85 # can't simply use clear_local_git_env since we want to preserve some
86 # of the settings from GIT_CONFIG_PARAMETERS.
87 sanitize_submodule_env()
89 save_config=$GIT_CONFIG_PARAMETERS
90 clear_local_git_env
91 GIT_CONFIG_PARAMETERS=$save_config
92 export GIT_CONFIG_PARAMETERS
96 # Add a new submodule to the working tree, .gitmodules and the index
98 # $@ = repo path
100 # optional branch is stored in global branch variable
102 cmd_add()
104 # parse $args after "submodule ... add".
105 reference_path=
106 while test $# -ne 0
108 case "$1" in
109 -b | --branch)
110 case "$2" in '') usage ;; esac
111 branch=$2
112 shift
114 -f | --force)
115 force=$1
117 -q|--quiet)
118 GIT_QUIET=1
120 --reference)
121 case "$2" in '') usage ;; esac
122 reference_path=$2
123 shift
125 --reference=*)
126 reference_path="${1#--reference=}"
128 --name)
129 case "$2" in '') usage ;; esac
130 custom_name=$2
131 shift
133 --depth)
134 case "$2" in '') usage ;; esac
135 depth="--depth=$2"
136 shift
138 --depth=*)
139 depth=$1
142 shift
143 break
146 usage
149 break
151 esac
152 shift
153 done
155 if test -n "$reference_path"
156 then
157 is_absolute_path "$reference_path" ||
158 reference_path="$wt_prefix$reference_path"
160 reference="--reference=$reference_path"
163 repo=$1
164 sm_path=$2
166 if test -z "$sm_path"; then
167 sm_path=$(printf '%s\n' "$repo" |
168 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
171 if test -z "$repo" || test -z "$sm_path"; then
172 usage
175 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
177 # assure repo is absolute or relative to parent
178 case "$repo" in
179 ./*|../*)
180 test -z "$wt_prefix" ||
181 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
183 # dereference source url relative to parent's url
184 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
186 *:*|/*)
187 # absolute url
188 realrepo=$repo
191 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
193 esac
195 # normalize path:
196 # multiple //; leading ./; /./; /../; trailing /
197 sm_path=$(printf '%s/\n' "$sm_path" |
198 sed -e '
199 s|//*|/|g
200 s|^\(\./\)*||
201 s|/\(\./\)*|/|g
202 :start
203 s|\([^/]*\)/\.\./||
204 tstart
205 s|/*$||
207 if test -z "$force"
208 then
209 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
210 die "$(eval_gettext "'\$sm_path' already exists in the index")"
211 else
212 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
213 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
216 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
217 then
218 eval_gettextln "The following path is ignored by one of your .gitignore files:
219 \$sm_path
220 Use -f if you really want to add it." >&2
221 exit 1
224 if test -n "$custom_name"
225 then
226 sm_name="$custom_name"
227 else
228 sm_name="$sm_path"
231 # perhaps the path exists and is already a git repo, else clone it
232 if test -e "$sm_path"
233 then
234 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
235 then
236 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
237 else
238 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
241 else
242 if test -d ".git/modules/$sm_name"
243 then
244 if test -z "$force"
245 then
246 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
247 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
248 die "$(eval_gettextln "\
249 If you want to reuse this local git directory instead of cloning again from
250 \$realrepo
251 use the '--force' option. If the local git directory is not the correct repo
252 or you are unsure what this means choose another name with the '--name' option.")"
253 else
254 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
257 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
259 sanitize_submodule_env
260 cd "$sm_path" &&
261 # ash fails to wordsplit ${branch:+-b "$branch"...}
262 case "$branch" in
263 '') git checkout -f -q ;;
264 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
265 esac
266 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
268 git config submodule."$sm_name".url "$realrepo"
270 git add $force "$sm_path" ||
271 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
273 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
274 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
275 if test -n "$branch"
276 then
277 git config -f .gitmodules submodule."$sm_name".branch "$branch"
278 fi &&
279 git add --force .gitmodules ||
280 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
284 # Execute an arbitrary command sequence in each checked out
285 # submodule
287 # $@ = command to execute
289 cmd_foreach()
291 # parse $args after "submodule ... foreach".
292 while test $# -ne 0
294 case "$1" in
295 -q|--quiet)
296 GIT_QUIET=1
298 --recursive)
299 recursive=1
302 usage
305 break
307 esac
308 shift
309 done
311 toplevel=$(pwd)
313 # dup stdin so that it can be restored when running the external
314 # command in the subshell (and a recursive call to this function)
315 exec 3<&0
318 git submodule--helper list --prefix "$wt_prefix" ||
319 echo "#unmatched" $?
321 while read mode sha1 stage sm_path
323 die_if_unmatched "$mode" "$sha1"
324 if test -e "$sm_path"/.git
325 then
326 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
327 say "$(eval_gettext "Entering '\$displaypath'")"
328 name=$(git submodule--helper name "$sm_path")
330 prefix="$prefix$sm_path/"
331 sanitize_submodule_env
332 cd "$sm_path" &&
333 sm_path=$(git submodule--helper relative-path "$sm_path" "$wt_prefix") &&
334 # we make $path available to scripts ...
335 path=$sm_path &&
336 if test $# -eq 1
337 then
338 eval "$1"
339 else
340 "$@"
341 fi &&
342 if test -n "$recursive"
343 then
344 cmd_foreach "--recursive" "$@"
346 ) <&3 3<&- ||
347 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
349 done
353 # Register submodules in .git/config
355 # $@ = requested paths (default to all)
357 cmd_init()
359 # parse $args after "submodule ... init".
360 while test $# -ne 0
362 case "$1" in
363 -q|--quiet)
364 GIT_QUIET=1
367 shift
368 break
371 usage
374 break
376 esac
377 shift
378 done
380 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
384 # Unregister submodules from .git/config and remove their work tree
386 cmd_deinit()
388 # parse $args after "submodule ... deinit".
389 deinit_all=
390 while test $# -ne 0
392 case "$1" in
393 -f|--force)
394 force=$1
396 -q|--quiet)
397 GIT_QUIET=1
399 --all)
400 deinit_all=t
403 shift
404 break
407 usage
410 break
412 esac
413 shift
414 done
416 if test -n "$deinit_all" && test "$#" -ne 0
417 then
418 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
419 usage
421 if test $# = 0 && test -z "$deinit_all"
422 then
423 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
427 git submodule--helper list --prefix "$wt_prefix" "$@" ||
428 echo "#unmatched" $?
430 while read mode sha1 stage sm_path
432 die_if_unmatched "$mode" "$sha1"
433 name=$(git submodule--helper name "$sm_path") || exit
435 displaypath=$(git submodule--helper relative-path "$sm_path" "$wt_prefix")
437 # Remove the submodule work tree (unless the user already did it)
438 if test -d "$sm_path"
439 then
440 # Protect submodules containing a .git directory
441 if test -d "$sm_path/.git"
442 then
443 die "$(eval_gettext "\
444 Submodule work tree '\$displaypath' contains a .git directory
445 (use 'rm -rf' if you really want to remove it including all of its history)")"
448 if test -z "$force"
449 then
450 git rm -qn "$sm_path" ||
451 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
453 rm -rf "$sm_path" &&
454 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
455 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
458 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
460 # Remove the .git/config entries (unless the user already did it)
461 if test -n "$(git config --get-regexp submodule."$name\.")"
462 then
463 # Remove the whole section so we have a clean state when
464 # the user later decides to init this submodule again
465 url=$(git config submodule."$name".url)
466 git config --remove-section submodule."$name" 2>/dev/null &&
467 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
469 done
472 is_tip_reachable () (
473 sanitize_submodule_env &&
474 cd "$1" &&
475 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
476 test -z "$rev"
479 fetch_in_submodule () (
480 sanitize_submodule_env &&
481 cd "$1" &&
482 case "$2" in
484 git fetch ;;
486 shift
487 git fetch $(get_default_remote) "$@" ;;
488 esac
492 # Update each submodule path to correct revision, using clone and checkout as needed
494 # $@ = requested paths (default to all)
496 cmd_update()
498 # parse $args after "submodule ... update".
499 while test $# -ne 0
501 case "$1" in
502 -q|--quiet)
503 GIT_QUIET=1
505 --progress)
506 progress="--progress"
508 -i|--init)
509 init=1
511 --remote)
512 remote=1
514 -N|--no-fetch)
515 nofetch=1
517 -f|--force)
518 force=$1
520 -r|--rebase)
521 update="rebase"
523 --reference)
524 case "$2" in '') usage ;; esac
525 reference="--reference=$2"
526 shift
528 --reference=*)
529 reference="$1"
531 -m|--merge)
532 update="merge"
534 --recursive)
535 recursive=1
537 --checkout)
538 update="checkout"
540 --recommend-shallow)
541 recommend_shallow="--recommend-shallow"
543 --no-recommend-shallow)
544 recommend_shallow="--no-recommend-shallow"
546 --depth)
547 case "$2" in '') usage ;; esac
548 depth="--depth=$2"
549 shift
551 --depth=*)
552 depth=$1
554 -j|--jobs)
555 case "$2" in '') usage ;; esac
556 jobs="--jobs=$2"
557 shift
559 --jobs=*)
560 jobs=$1
563 shift
564 break
567 usage
570 break
572 esac
573 shift
574 done
576 if test -n "$init"
577 then
578 cmd_init "--" "$@" || return
582 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
583 ${progress:+"$progress"} \
584 ${wt_prefix:+--prefix "$wt_prefix"} \
585 ${prefix:+--recursive-prefix "$prefix"} \
586 ${update:+--update "$update"} \
587 ${reference:+"$reference"} \
588 ${depth:+--depth "$depth"} \
589 ${recommend_shallow:+"$recommend_shallow"} \
590 ${jobs:+$jobs} \
591 "$@" || echo "#unmatched" $?
592 } | {
593 err=
594 while read mode sha1 stage just_cloned sm_path
596 die_if_unmatched "$mode" "$sha1"
598 name=$(git submodule--helper name "$sm_path") || exit
599 url=$(git config submodule."$name".url)
600 if ! test -z "$update"
601 then
602 update_module=$update
603 else
604 update_module=$(git config submodule."$name".update)
605 if test -z "$update_module"
606 then
607 update_module="checkout"
611 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
613 if test $just_cloned -eq 1
614 then
615 subsha1=
616 update_module=checkout
617 else
618 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
619 git rev-parse --verify HEAD) ||
620 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
623 if test -n "$remote"
624 then
625 branch=$(git submodule--helper remote-branch "$sm_path")
626 if test -z "$nofetch"
627 then
628 # Fetch remote before determining tracking $sha1
629 fetch_in_submodule "$sm_path" $depth ||
630 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
632 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
633 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
634 git rev-parse --verify "${remote_name}/${branch}") ||
635 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
638 if test "$subsha1" != "$sha1" || test -n "$force"
639 then
640 subforce=$force
641 # If we don't already have a -f flag and the submodule has never been checked out
642 if test -z "$subsha1" && test -z "$force"
643 then
644 subforce="-f"
647 if test -z "$nofetch"
648 then
649 # Run fetch only if $sha1 isn't present or it
650 # is not reachable from a ref.
651 is_tip_reachable "$sm_path" "$sha1" ||
652 fetch_in_submodule "$sm_path" $depth ||
653 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
655 # Now we tried the usual fetch, but $sha1 may
656 # not be reachable from any of the refs
657 is_tip_reachable "$sm_path" "$sha1" ||
658 fetch_in_submodule "$sm_path" $depth "$sha1" ||
659 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
662 must_die_on_failure=
663 case "$update_module" in
664 checkout)
665 command="git checkout $subforce -q"
666 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
667 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
669 rebase)
670 command="git rebase"
671 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
672 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
673 must_die_on_failure=yes
675 merge)
676 command="git merge"
677 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
678 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
679 must_die_on_failure=yes
682 command="${update_module#!}"
683 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
684 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
685 must_die_on_failure=yes
688 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
689 esac
691 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
692 then
693 say "$say_msg"
694 elif test -n "$must_die_on_failure"
695 then
696 die_with_status 2 "$die_msg"
697 else
698 err="${err};$die_msg"
699 continue
703 if test -n "$recursive"
704 then
706 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
707 wt_prefix=
708 sanitize_submodule_env
709 cd "$sm_path" &&
710 eval cmd_update
712 res=$?
713 if test $res -gt 0
714 then
715 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
716 if test $res -ne 2
717 then
718 err="${err};$die_msg"
719 continue
720 else
721 die_with_status $res "$die_msg"
725 done
727 if test -n "$err"
728 then
729 OIFS=$IFS
730 IFS=';'
731 for e in $err
733 if test -n "$e"
734 then
735 echo >&2 "$e"
737 done
738 IFS=$OIFS
739 exit 1
744 set_name_rev () {
745 revname=$( (
746 sanitize_submodule_env
747 cd "$1" && {
748 git describe "$2" 2>/dev/null ||
749 git describe --tags "$2" 2>/dev/null ||
750 git describe --contains "$2" 2>/dev/null ||
751 git describe --all --always "$2"
754 test -z "$revname" || revname=" ($revname)"
757 # Show commit summary for submodules in index or working tree
759 # If '--cached' is given, show summary between index and given commit,
760 # or between working tree and given commit
762 # $@ = [commit (default 'HEAD'),] requested paths (default all)
764 cmd_summary() {
765 summary_limit=-1
766 for_status=
767 diff_cmd=diff-index
769 # parse $args after "submodule ... summary".
770 while test $# -ne 0
772 case "$1" in
773 --cached)
774 cached="$1"
776 --files)
777 files="$1"
779 --for-status)
780 for_status="$1"
782 -n|--summary-limit)
783 summary_limit="$2"
784 isnumber "$summary_limit" || usage
785 shift
787 --summary-limit=*)
788 summary_limit="${1#--summary-limit=}"
789 isnumber "$summary_limit" || usage
792 shift
793 break
796 usage
799 break
801 esac
802 shift
803 done
805 test $summary_limit = 0 && return
807 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
808 then
809 head=$rev
810 test $# = 0 || shift
811 elif test -z "$1" || test "$1" = "HEAD"
812 then
813 # before the first commit: compare with an empty tree
814 head=$(git hash-object -w -t tree --stdin </dev/null)
815 test -z "$1" || shift
816 else
817 head="HEAD"
820 if [ -n "$files" ]
821 then
822 test -n "$cached" &&
823 die "$(gettext "The --cached option cannot be used with the --files option")"
824 diff_cmd=diff-files
825 head=
828 cd_to_toplevel
829 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
830 # Get modified modules cared by user
831 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
832 sane_egrep '^:([0-7]* )?160000' |
833 while read mod_src mod_dst sha1_src sha1_dst status sm_path
835 # Always show modules deleted or type-changed (blob<->module)
836 if test "$status" = D || test "$status" = T
837 then
838 printf '%s\n' "$sm_path"
839 continue
841 # Respect the ignore setting for --for-status.
842 if test -n "$for_status"
843 then
844 name=$(git submodule--helper name "$sm_path")
845 ignore_config=$(get_submodule_config "$name" ignore none)
846 test $status != A && test $ignore_config = all && continue
848 # Also show added or modified modules which are checked out
849 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
850 printf '%s\n' "$sm_path"
851 done
854 test -z "$modules" && return
856 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
857 sane_egrep '^:([0-7]* )?160000' |
858 cut -c2- |
859 while read mod_src mod_dst sha1_src sha1_dst status name
861 if test -z "$cached" &&
862 test $sha1_dst = 0000000000000000000000000000000000000000
863 then
864 case "$mod_dst" in
865 160000)
866 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
868 100644 | 100755 | 120000)
869 sha1_dst=$(git hash-object $name)
871 000000)
872 ;; # removed
874 # unexpected type
875 eval_gettextln "unexpected mode \$mod_dst" >&2
876 continue ;;
877 esac
879 missing_src=
880 missing_dst=
882 test $mod_src = 160000 &&
883 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
884 missing_src=t
886 test $mod_dst = 160000 &&
887 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
888 missing_dst=t
890 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
892 total_commits=
893 case "$missing_src,$missing_dst" in
895 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
898 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
900 t,t)
901 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
904 errmsg=
905 total_commits=$(
906 if test $mod_src = 160000 && test $mod_dst = 160000
907 then
908 range="$sha1_src...$sha1_dst"
909 elif test $mod_src = 160000
910 then
911 range=$sha1_src
912 else
913 range=$sha1_dst
915 GIT_DIR="$name/.git" \
916 git rev-list --first-parent $range -- | wc -l
918 total_commits=" ($(($total_commits + 0)))"
920 esac
922 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
923 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
924 if test $status = T
925 then
926 blob="$(gettext "blob")"
927 submodule="$(gettext "submodule")"
928 if test $mod_dst = 160000
929 then
930 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
931 else
932 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
934 else
935 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
937 if test -n "$errmsg"
938 then
939 # Don't give error msg for modification whose dst is not submodule
940 # i.e. deleted or changed to blob
941 test $mod_dst = 160000 && echo "$errmsg"
942 else
943 if test $mod_src = 160000 && test $mod_dst = 160000
944 then
945 limit=
946 test $summary_limit -gt 0 && limit="-$summary_limit"
947 GIT_DIR="$name/.git" \
948 git log $limit --pretty='format: %m %s' \
949 --first-parent $sha1_src...$sha1_dst
950 elif test $mod_dst = 160000
951 then
952 GIT_DIR="$name/.git" \
953 git log --pretty='format: > %s' -1 $sha1_dst
954 else
955 GIT_DIR="$name/.git" \
956 git log --pretty='format: < %s' -1 $sha1_src
958 echo
960 echo
961 done
964 # List all submodules, prefixed with:
965 # - submodule not initialized
966 # + different revision checked out
968 # If --cached was specified the revision in the index will be printed
969 # instead of the currently checked out revision.
971 # $@ = requested paths (default to all)
973 cmd_status()
975 # parse $args after "submodule ... status".
976 while test $# -ne 0
978 case "$1" in
979 -q|--quiet)
980 GIT_QUIET=1
982 --cached)
983 cached=1
985 --recursive)
986 recursive=1
989 shift
990 break
993 usage
996 break
998 esac
999 shift
1000 done
1003 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1004 echo "#unmatched" $?
1006 while read mode sha1 stage sm_path
1008 die_if_unmatched "$mode" "$sha1"
1009 name=$(git submodule--helper name "$sm_path") || exit
1010 url=$(git config submodule."$name".url)
1011 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1012 if test "$stage" = U
1013 then
1014 say "U$sha1 $displaypath"
1015 continue
1017 if test -z "$url" ||
1019 ! test -d "$sm_path"/.git &&
1020 ! test -f "$sm_path"/.git
1022 then
1023 say "-$sha1 $displaypath"
1024 continue;
1026 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1027 then
1028 set_name_rev "$sm_path" "$sha1"
1029 say " $sha1 $displaypath$revname"
1030 else
1031 if test -z "$cached"
1032 then
1033 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
1035 set_name_rev "$sm_path" "$sha1"
1036 say "+$sha1 $displaypath$revname"
1039 if test -n "$recursive"
1040 then
1042 prefix="$displaypath/"
1043 sanitize_submodule_env
1044 wt_prefix=
1045 cd "$sm_path" &&
1046 eval cmd_status
1047 ) ||
1048 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1050 done
1053 # Sync remote urls for submodules
1054 # This makes the value for remote.$remote.url match the value
1055 # specified in .gitmodules.
1057 cmd_sync()
1059 while test $# -ne 0
1061 case "$1" in
1062 -q|--quiet)
1063 GIT_QUIET=1
1064 shift
1066 --recursive)
1067 recursive=1
1068 shift
1071 shift
1072 break
1075 usage
1078 break
1080 esac
1081 done
1082 cd_to_toplevel
1084 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1085 echo "#unmatched" $?
1087 while read mode sha1 stage sm_path
1089 die_if_unmatched "$mode" "$sha1"
1090 name=$(git submodule--helper name "$sm_path")
1091 url=$(git config -f .gitmodules --get submodule."$name".url)
1093 # Possibly a url relative to parent
1094 case "$url" in
1095 ./*|../*)
1096 # rewrite foo/bar as ../.. to find path from
1097 # submodule work tree to superproject work tree
1098 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1099 # guarantee a trailing /
1100 up_path=${up_path%/}/ &&
1101 # path from submodule work tree to submodule origin repo
1102 sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
1103 # path from superproject work tree to submodule origin repo
1104 super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
1107 sub_origin_url="$url"
1108 super_config_url="$url"
1110 esac
1112 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1113 then
1114 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1115 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1116 git config submodule."$name".url "$super_config_url"
1118 if test -e "$sm_path"/.git
1119 then
1121 sanitize_submodule_env
1122 cd "$sm_path"
1123 remote=$(get_default_remote)
1124 git config remote."$remote".url "$sub_origin_url"
1126 if test -n "$recursive"
1127 then
1128 prefix="$prefix$sm_path/"
1129 eval cmd_sync
1134 done
1137 cmd_absorbgitdirs()
1139 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
1142 # This loop parses the command line arguments to find the
1143 # subcommand name to dispatch. Parsing of the subcommand specific
1144 # options are primarily done by the subcommand implementations.
1145 # Subcommand specific options such as --branch and --cached are
1146 # parsed here as well, for backward compatibility.
1148 while test $# != 0 && test -z "$command"
1150 case "$1" in
1151 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
1152 command=$1
1154 -q|--quiet)
1155 GIT_QUIET=1
1157 -b|--branch)
1158 case "$2" in
1160 usage
1162 esac
1163 branch="$2"; shift
1165 --cached)
1166 cached="$1"
1169 break
1172 usage
1175 break
1177 esac
1178 shift
1179 done
1181 # No command word defaults to "status"
1182 if test -z "$command"
1183 then
1184 if test $# = 0
1185 then
1186 command=status
1187 else
1188 usage
1192 # "-b branch" is accepted only by "add"
1193 if test -n "$branch" && test "$command" != add
1194 then
1195 usage
1198 # "--cached" is accepted only by "status" and "summary"
1199 if test -n "$cached" && test "$command" != status && test "$command" != summary
1200 then
1201 usage
1204 "cmd_$command" "$@"